// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Tracing implementation internals
#include "verilated_vcd_c.h"
#include "VMESI__Syms.h"


void VMESI::traceChgTop0(void* userp, VerilatedVcd* tracep) {
    VMESI__Syms* __restrict vlSymsp = static_cast<VMESI__Syms*>(userp);
    VMESI* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Variables
    if (VL_UNLIKELY(!vlSymsp->__Vm_activity)) return;
    // Body
    {
        vlTOPp->traceChgSub0(userp, tracep);
    }
}

void VMESI::traceChgSub0(void* userp, VerilatedVcd* tracep) {
    VMESI__Syms* __restrict vlSymsp = static_cast<VMESI__Syms*>(userp);
    VMESI* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    vluint32_t* const oldp = tracep->oldp(vlSymsp->__Vm_baseCode + 1);
    if (false && oldp) {}  // Prevent unused
    // Body
    {
        if (VL_UNLIKELY(vlTOPp->__Vm_traceActivity[0U])) {
            tracep->chgIData(oldp+0,(vlTOPp->MESI__DOT__MESI_RAM__DOT__i),32);
            tracep->chgIData(oldp+1,(vlTOPp->MESI__DOT__TAG_RAM__DOT__i),32);
        }
        if (VL_UNLIKELY(vlTOPp->__Vm_traceActivity[1U])) {
            tracep->chgCData(oldp+2,(vlTOPp->MESI__DOT__NEXT_STATE),3);
            tracep->chgBit(oldp+3,(vlTOPp->MESI__DOT__IDLE));
            tracep->chgBit(oldp+4,(vlTOPp->MESI__DOT__IS_EXCLUSIVE));
            tracep->chgBit(oldp+5,(vlTOPp->MESI__DOT__IS_INVALID));
            tracep->chgBit(oldp+6,(vlTOPp->MESI__DOT__IS_MODIFIED));
            tracep->chgBit(oldp+7,(vlTOPp->MESI__DOT__IS_SHARED));
            tracep->chgBit(oldp+8,(vlTOPp->MESI__DOT__MESI_READ));
            tracep->chgBit(oldp+9,(vlTOPp->MESI__DOT__MESI_WRITE));
            tracep->chgBit(oldp+10,(vlTOPp->MESI__DOT__READ));
            tracep->chgBit(oldp+11,(vlTOPp->MESI__DOT__TAG_MATCH));
            tracep->chgBit(oldp+12,(vlTOPp->MESI__DOT__TAG_READ));
            tracep->chgBit(oldp+13,(vlTOPp->MESI__DOT__TAG_WRITE));
            tracep->chgBit(oldp+14,(vlTOPp->MESI__DOT__WRITE));
            tracep->chgBit(oldp+15,(vlTOPp->MESI__DOT__rREAD));
            tracep->chgBit(oldp+16,(vlTOPp->MESI__DOT__rWRITE));
            tracep->chgBit(oldp+17,(vlTOPp->MESI__DOT__MESI_RAM_rd));
            tracep->chgCData(oldp+18,(vlTOPp->MESI__DOT__MESI_RAM_rd_data),4);
            tracep->chgCData(oldp+19,(vlTOPp->MESI__DOT__MESI_RAM_rd_addr),6);
            tracep->chgBit(oldp+20,(vlTOPp->MESI__DOT__MESI_RAM_wr));
            tracep->chgCData(oldp+21,(vlTOPp->MESI__DOT__MESI_RAM_wr_data),4);
            tracep->chgCData(oldp+22,(vlTOPp->MESI__DOT__MESI_RAM_wr_addr),6);
            tracep->chgBit(oldp+23,(vlTOPp->MESI__DOT__TAG_RAM_rd));
            tracep->chgIData(oldp+24,(vlTOPp->MESI__DOT__TAG_RAM_rd_data),24);
            tracep->chgCData(oldp+25,(vlTOPp->MESI__DOT__TAG_RAM_rd_addr),6);
            tracep->chgBit(oldp+26,(vlTOPp->MESI__DOT__TAG_RAM_wr));
            tracep->chgIData(oldp+27,(vlTOPp->MESI__DOT__TAG_RAM_wr_data),24);
            tracep->chgCData(oldp+28,(vlTOPp->MESI__DOT__TAG_RAM_wr_addr),6);
        }
        tracep->chgBit(oldp+29,(vlTOPp->clk));
        tracep->chgBit(oldp+30,(vlTOPp->res_n));
        tracep->chgIData(oldp+31,(vlTOPp->addr),32);
        tracep->chgBit(oldp+32,(vlTOPp->cp));
        tracep->chgBit(oldp+33,(vlTOPp->rd));
        tracep->chgBit(oldp+34,(vlTOPp->wr));
        tracep->chgCData(oldp+35,(vlTOPp->mesi),4);
        tracep->chgCData(oldp+36,(vlTOPp->index),6);
        tracep->chgBit(oldp+37,(vlTOPp->err));
        tracep->chgCData(oldp+38,(vlTOPp->MESI__DOT__STATE),3);
    }
}

void VMESI::traceCleanup(void* userp, VerilatedVcd* /*unused*/) {
    VMESI__Syms* __restrict vlSymsp = static_cast<VMESI__Syms*>(userp);
    VMESI* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    {
        vlSymsp->__Vm_activity = false;
        vlTOPp->__Vm_traceActivity[0U] = 0U;
        vlTOPp->__Vm_traceActivity[1U] = 0U;
    }
}
